package edu.nju.controller;


import edu.nju.entities.ReviewJob;
import edu.nju.service.ReviewJobService;
import org.json.JSONArray;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;


import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

@Controller
@RequestMapping(value = "/crowdsourcingToReview")
@CrossOrigin(origins = "*", maxAge = 3600, allowCredentials = "true")
public class CrowdsourcingToReviewController {

    @Autowired
    ReviewJobService rService;


    @RequestMapping(value = "/examId")
    @ResponseBody
    public String getExamIdByJobId(String jobId) {
        ReviewJob reviewJob=rService.getJob(jobId);
        String result="";
        if(reviewJob!=null){
            String temp=reviewJob.getExam_id();
            if(temp!=null)
                result=temp;
        }
        return result;
    }

    @RequestMapping(value = "jobId")
    @ResponseBody
    public List<String> getJobIdByExamId(String examId) {
            List<ReviewJob> jobs=rService.getJobsByExam(examId);
            List<String>result=new ArrayList<>();
            if(jobs!=null){
                for(ReviewJob reviewJob:jobs){
                    result.add(reviewJob.getId());
                }
            }
            return result;
    }

}
