package edu.nju.controller;

import edu.nju.entities.*;
import edu.nju.model.ReviewWorkerVO;
import edu.nju.service.NodeService;
import edu.nju.service.ReviewService;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

@Controller
@RequestMapping(value = "/node")
@CrossOrigin(origins = "*", maxAge = 3600, allowCredentials = "true")
public class NodeController {

    @Autowired
    NodeService nodeService;

    @RequestMapping(value = "/generateBasicNode")
    @ResponseBody
    public void generateBasicNode(String jobId,String teacherId, HttpServletResponse response){
        try {
            PrintWriter out = response.getWriter();
            BasicNode basicNode=nodeService.generateBasicNode(jobId,teacherId);
            out.print(new JSONObject(basicNode));
            out.flush();
            out.close();
        }catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }


    @RequestMapping(value = "/generateCatchNode")
    @ResponseBody
    public void generateCatchNode(String jobId,String workerId, HttpServletResponse response){
        try {
            PrintWriter out = response.getWriter();
            AnswerNode answerNode=nodeService.generateCatchNode(jobId,workerId);
            out.print(new JSONObject(answerNode));
            out.flush();
            out.close();
        }catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    @RequestMapping(value = "/getBasicNode")
    @ResponseBody
    public void getBasicNode(String jobId,String teacherId, HttpServletResponse response){
        try {
            PrintWriter out = response.getWriter();
            BasicNode basicNode=nodeService.getBasicNode(jobId,teacherId);
            out.print(new JSONObject(basicNode));
            out.flush();
            out.close();
        }catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    @RequestMapping(value = "/uploadCatchNode")
    @ResponseBody
    public void uploadCatchNode(String jobId,HttpServletResponse response){
        JSONObject result;
        try {
            PrintWriter out = response.getWriter();
            result=nodeService.uploadCatchNodeToMoocTest(jobId);
            out.print(result);
            out.flush();
            out.close();
        }catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    @RequestMapping(value = "/uploadSingleCatchNode")
    @ResponseBody
    public void uploadSingleCatchNode(String jobId,String workerId,HttpServletResponse response){
        JSONObject result;
        try {
            PrintWriter out = response.getWriter();
            result=nodeService.uploadSingleCatchNodeToMoocTest(jobId,workerId);
            out.print(result);
            out.flush();
            out.close();
        }catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }





}
