package edu.nju.dao;

import edu.nju.entities.AnswerNode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.stereotype.Repository;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;

import java.util.List;

@Repository
public class AnswerNodeDao {


    @Autowired
    private MongoOperations mongoOperations;


    //save存在则更新，不存在则插入
    public String save(AnswerNode answerNode) {
        mongoOperations.save(answerNode);
        return answerNode.getId();
    }

    public AnswerNode find(String id){
        Query query = new Query();
        query.addCriteria(Criteria.where("_id").is(id));
        List<AnswerNode> list = mongoOperations.find(query,AnswerNode.class);
        if(list.size() == 0 ) {return null;}
        return list.get(0);
    }

    public AnswerNode findByJobWorker(String jobId,String workerId){
        Query query = new Query();
        query.addCriteria(Criteria.where("jobId").is(jobId).and("workerId").is(workerId));
        List<AnswerNode> list = mongoOperations.find(query,AnswerNode.class);
        if(list.size() == 0 ) {return null;}
        return list.get(0);
    }




}
