package edu.nju.dao;

import edu.nju.entities.BasicNode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.stereotype.Repository;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;

import java.util.ArrayList;
import java.util.List;

@Repository
public class BasicNodeDao {


    @Autowired
    private MongoOperations mongoOperations;


    //save存在则更新，不存在则插入
    public String save(BasicNode basicNode) {
        mongoOperations.save(basicNode);
        return basicNode.getId();
    }

    public BasicNode findByJobTeacher(String jobId,String teacherId){
        Query query = new Query();
        query.addCriteria(Criteria.where("jobId").is(jobId).and("teacherId").is(teacherId));
        List<BasicNode> basicNodeList = mongoOperations.find(query,BasicNode.class);
        if(basicNodeList.size()!=0) {
            return basicNodeList.get(0);
        }
        return null;
    }




}
