package edu.nju.dao;

import edu.nju.entities.BugScoreByWorker;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class BugScoreByWorkerDao {

    @Autowired
    private MongoOperations mongoOperations;

    public void save(BugScoreByWorker score) {
        mongoOperations.save(score);
    }

    public void remove(List<String> ids) {
        Query query = new Query();
        query.addCriteria(Criteria.where("bug_id").in(ids));
        mongoOperations.remove(query, BugScoreByWorker.class);
    }
}
