package edu.nju.dao;

import edu.nju.entities.CrowdSourceToReviewPaper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class CrowdSourceToReviewPaperDao {

    @Autowired
    private MongoOperations mongoOperations;

    public String save(CrowdSourceToReviewPaper paper) {
        mongoOperations.save(paper);
        return paper.getId();
    }

    public CrowdSourceToReviewPaper getByCaseTakeId(String caseTakeId){
        Query query = new Query();
        query.addCriteria(Criteria.where("case_take_id").is(caseTakeId));
        List<CrowdSourceToReviewPaper> list = mongoOperations.find(query,CrowdSourceToReviewPaper.class);
        if(list.size() == 0 || list == null) {return null;}
        return list.get(0);
    }
}
