package edu.nju.dao;


import edu.nju.entities.ReviewCorrectAnswer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class ReviewCorrectAnswerDao {

    @Autowired
    private MongoOperations mongoOperations;

    public String save(ReviewCorrectAnswer reviewCorrectAnswer){
        mongoOperations.save(reviewCorrectAnswer);
        return reviewCorrectAnswer.getId();
    }

    public ReviewCorrectAnswer findCorrectAnswerByReportItem(String reportId,String itemId,String jobId){
        Query query = new Query();
        query.addCriteria(Criteria.where("report_id").is(reportId).and("item_id").is(itemId).and("job_id").is(jobId));
        List<ReviewCorrectAnswer> answers= mongoOperations.find(query, ReviewCorrectAnswer.class);
        if(answers==null||answers.size()==0){
            return null;
        }
        return answers.get(0);
    }

    public ReviewCorrectAnswer getCorrectAnswerById(String id){
        Query query = new Query();
        query.addCriteria(Criteria.where("_id").is(id));
        List<ReviewCorrectAnswer> list = mongoOperations.find(query, ReviewCorrectAnswer.class);
        if(list == null||list.size() == 0) {return null;}
        return list.get(0);
    }
}
