package edu.nju.dao;

import edu.nju.entities.ReviewGroup;
import edu.nju.entities.ReviewJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class ReviewGroupDao {

    @Autowired
    private MongoOperations mongoOperations;

    //存在则更新，不存在则插入
    public String save(ReviewGroup group){
        mongoOperations.save(group);
        return group.getId();
    }

    public List<String>getReportsByUserJob(String worker_id,String job_id){
        Query query = new Query();
        query.addCriteria(Criteria.where("workers_id").is(worker_id).and("job_id").is(job_id));
        List<ReviewGroup>list = mongoOperations.find(query, ReviewGroup.class);
        if(list == null||list.size() == 0) {return null;}
        return list.get(0).getReport_id();
    }

    public void removeByJob(String jobId){
        Query query = new Query();
        query.addCriteria(Criteria.where("job_id").is(jobId));
        mongoOperations.remove(query,ReviewJob.class);
    }

    public ReviewGroup getGroupByReports(List<String>reportIds){
        Query query = new Query();
        query.addCriteria(Criteria.where("report_id").is(reportIds));
        List<ReviewGroup>list = mongoOperations.find(query, ReviewGroup.class);
        if(list == null||list.size() == 0) {return null;}
        return list.get(0);
    }

    public List<ReviewGroup>getGroupsByJob(String job_id){
        Query query = new Query();
        query.addCriteria(Criteria.where("job_id").is(job_id));
        List<ReviewGroup>list = mongoOperations.find(query, ReviewGroup.class);
        return list;
    }

    public ReviewGroup getGroupByWorkers(List<String>workerIds){
        Query query = new Query();
        query.addCriteria(Criteria.where("workers_id").is(workerIds));
        List<ReviewGroup>list = mongoOperations.find(query, ReviewGroup.class);
        if(list == null||list.size() == 0) {return null;}
        return list.get(0);
    }

}
