package edu.nju.dao;


import edu.nju.entities.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;


import java.util.List;

@Repository
public class ReviewItemDao {

    @Autowired
    private MongoOperations mongoOperations;

    public String saveItem(ReviewItem item){
        mongoOperations.save(item);
        return item.getId();
    }

//    public List<ReviewItem>findItemsByJob(String job_id){
//        Query query = new Query();
//        query.addCriteria(Criteria.where("job_id").is(job_id));
//        return mongoOperations.find(query, ReviewItem.class);
//    }

    public List<ReviewItem> findItemsByReport(String report_id){
        Query query = new Query();
        query.addCriteria(Criteria.where("report_id").is(report_id));
        List<ReviewItem>reviewItems=mongoOperations.find(query, ReviewItem.class);
        return reviewItems;
    }

    public ReviewItem findById(String item_id){
        Query query = new Query();
        query.addCriteria(Criteria.where("_id").is(item_id));
        List<ReviewItem>list=mongoOperations.find(query, ReviewItem.class);
        if(list==null||list.size()==0)
            return null;
        else
            return list.get(0);
    }

//    public Item getItem(String id){
//        Query query = new Query();
//        query.addCriteria(Criteria.where("_id").is(id));
//        List<Item> list = mongoOperations.find(query, Item.class);
//        if(list.size() == 0 || list == null) {return null;}
//        return list.get(0);
//    }
    public void removeByPaper(String paperId){
        Query query = new Query();
        query.addCriteria(Criteria.where("paper_id").is(paperId));
        mongoOperations.remove(query,ReviewItem.class);
    }

    public List<ReviewItem> findItemsByPaper(String paperId){
        Query query = new Query();
        query.addCriteria(Criteria.where("paper_id").is(paperId));
        return mongoOperations.find(query, ReviewItem.class);
    }




}

