package edu.nju.dao;

import edu.nju.entities.ReviewJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class ReviewJobDao {

    @Autowired
    private MongoOperations mongoOperations;

    //id查询，find查询所有
    public ReviewJob findJob(String id){
        Query query = new Query();
        query.addCriteria(Criteria.where("_id").is(id));
        List<ReviewJob> list = mongoOperations.find(query,ReviewJob.class);
        if(list == null||list.size() == 0  ) {return null;}
        return list.get(0);
    }

    public ReviewJob findJobByExamCase(String examId,String caseId){
        Query query = new Query();
        query.addCriteria(Criteria.where("exam_id").is(examId).and("case_id").is(caseId));
        List<ReviewJob> list = mongoOperations.find(query,ReviewJob.class);
        if(list == null||list.size() == 0) {return null;}
        return list.get(0);
    }

    public List<ReviewJob> findJobs(){
        Query query = new Query().with(new Sort(Sort.Direction.DESC,"create_time"));;
        List<ReviewJob> list = mongoOperations.find(query,ReviewJob.class);
        return list;
    }

    public String save(ReviewJob job) {
        mongoOperations.save(job);
        return job.getId();
    }

    public void remove(String id){
        Query query = new Query();
        query.addCriteria(Criteria.where("_id").is(id));
        mongoOperations.remove(query,ReviewJob.class);
    }

    public List<ReviewJob> findJobsByPaper(String paperId){
        Query query = new Query();
        query.addCriteria(Criteria.where("paper_id").is(paperId));
        List<ReviewJob> list = mongoOperations.find(query,ReviewJob.class);
        return list;
    }

    public List<ReviewJob> findJobsByExam(String examId){
        Query query = new Query();
        query.addCriteria(Criteria.where("exam_id").is(examId));
        List<ReviewJob> list = mongoOperations.find(query,ReviewJob.class);
        return list;
    }

}
