package edu.nju.dao;

import edu.nju.entities.ReviewPaper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.data.web.SpringDataWebProperties;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class ReviewPaperDao {

    @Autowired
    private MongoOperations mongoOperations;

    public ReviewPaper findPaper(String id){
        Query query = new Query();
        query.addCriteria(Criteria.where("_id").is(id));
        List<ReviewPaper> list = mongoOperations.find(query,ReviewPaper.class);
        if(list == null||list.size() == 0 ) {return null;}
        return list.get(0);
    }

    public String save(ReviewPaper paper) {
        mongoOperations.save(paper);
        return paper.getId();
    }

    public List<ReviewPaper> findPapers(){
        Query query = new Query().with(new Sort(Sort.Direction.DESC,"create_time"));
        return mongoOperations.find(query,ReviewPaper.class);
    }

    public void remove(String id){
        Query query = new Query();
        query.addCriteria(Criteria.where("_id").is(id));
        mongoOperations.remove(query,ReviewPaper.class);
    }

}
