package edu.nju.dao;

import edu.nju.entities.ReviewPaperJson;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class ReviewPaperJsonDao {

    @Autowired
    private MongoOperations mongoOperations;

    //id查询，find查询所有
    public ReviewPaperJson findJsonByPaper(String paperId){
        Query query = new Query();
        query.addCriteria(Criteria.where("paper_id").is(paperId));
        List<ReviewPaperJson> list = mongoOperations.find(query,ReviewPaperJson.class);
        if(list == null||list.size() == 0 ) {return null;}
        return list.get(0);
    }

    public String save(ReviewPaperJson reviewPaperJson) {
        mongoOperations.save(reviewPaperJson);
        return reviewPaperJson.getId();
    }

    public void remove(String paperId){
        Query query = new Query();
        query.addCriteria(Criteria.where("paper_id").is(paperId));
        mongoOperations.remove(query,ReviewPaperJson.class);
    }

    public void update(String paperId,String paperJson){
        ReviewPaperJson reviewPaperJson=findJsonByPaper(paperId);
        reviewPaperJson.setJson(paperJson);
        save(reviewPaperJson);
    }
}
