package edu.nju.dao;

import edu.nju.entities.ReviewReport;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class ReviewReportDao {

    @Autowired
    private MongoOperations mongoOperations;

    //id查询，find查询所有
    public ReviewReport findReviewReport(String id){
        Query query = new Query();
        query.addCriteria(Criteria.where("_id").is(id));
        List<ReviewReport> list = mongoOperations.find(query,ReviewReport.class);
        if(list == null||list.size() == 0) {return null;}
        return list.get(0);
    }

    public ReviewReport findReportByPaperOriginalId(String paperId,String originalId){
        Query query = new Query();
        query.addCriteria(Criteria.where("paper_id").is(paperId).and("original_id").is(originalId));
        List<ReviewReport> list = mongoOperations.find(query,ReviewReport.class);
        if(list == null||list.size() == 0) {return null;}
        return list.get(0);
    }

    public String save(ReviewReport report) {
        mongoOperations.save(report);
        return report.getId();
    }

    public List<ReviewReport>getReportsByPaperId(String paperId){
        Query query = new Query();
        query.addCriteria(Criteria.where("paper_id").is(paperId));
        List<ReviewReport> list = mongoOperations.find(query,ReviewReport.class);
        return list;
    }

    public void removeByPaper(String paperId){
        Query query = new Query();
        query.addCriteria(Criteria.where("paper_id").is(paperId));
        mongoOperations.remove(query,ReviewReport.class);
    }
}

