package edu.nju.dao;

import edu.nju.entities.UserToItem;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class UserToItemDao {

    @Autowired
    private MongoOperations mongoOperations;

    public List<String>getItemsByUserJob(String worker_id,String job_id){
        Query query = new Query();
        query.addCriteria(Criteria.where("worker_id").is(worker_id).and("job_id").is(job_id));
        List<UserToItem>list = mongoOperations.find(query, UserToItem.class);
        if(list.size() == 0 || list == null) {return null;}
        return list.get(0).getItem_id();
    }

    //存在则更新，不存在则插入
    public String save(UserToItem userToItem){
        mongoOperations.save(userToItem);
        return userToItem.getId();
    }
}
