package edu.nju.entities;

import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.PersistenceConstructor;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.ArrayList;
import java.util.List;

@Document
public class ReviewAnswer implements java.io.Serializable{


    private static final long serialVersionUID = -8263451883506704407L;

    @Id
    private String id;

    private String item_id;

    private String report_id;

    private List<String> answers;

    private String worker_id;

    private String job_id;

    private String paper_id;

    private List<String> file_url;

    private String grade;

    private boolean is_finished;

    @PersistenceConstructor
    public ReviewAnswer(String item_id,String report_id, List<String> answers, String worker_id, List<String> file_url,String job_id,String paper_id,Boolean is_finished) {
        this.item_id = item_id;
        this.report_id=report_id;
        this.answers = answers;
        this.worker_id = worker_id;
        this.file_url=file_url;
        this.job_id=job_id;
        this.paper_id=paper_id;
        this.grade="";
        if(is_finished==null)
            this.is_finished=true;
        else
            this.is_finished=is_finished;
    }
    @PersistenceConstructor
    public ReviewAnswer(String item_id,String report_id,String worker_id,String job_id,String paper_id){
        this.item_id = item_id;
        this.report_id=report_id;
        this.worker_id = worker_id;
        this.file_url = new ArrayList<>();
        this.job_id=job_id;
        this.paper_id=paper_id;
        this.answers=new ArrayList<>();
        this.grade="";
        this.is_finished=false;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getItem_id() {
        return item_id;
    }

    public void setItem_id(String item_id) {
        this.item_id = item_id;
    }

    public String getReport_id() {
        return report_id;
    }

    public void setReport_id(String report_id) {
        this.report_id = report_id;
    }

    public List<String> getAnswers() {
        return answers;
    }

    public void setAnswers(List<String> answers) {
        this.answers = answers;
    }

    public String getWorker_id() {
        return worker_id;
    }

    public void setWorker_id(String worker_id) {
        this.worker_id = worker_id;
    }

    public List<String> getFile_url() {
        return file_url;
    }

    public void setFile_url(List<String> file_url) {
        this.file_url = file_url;
    }

    public String getJob_id() {
        return job_id;
    }

    public void setJob_id(String job_id) {
        this.job_id = job_id;
    }

    public String getPaper_id() {
        return paper_id;
    }

    public void setPaper_id(String paper_id) {
        this.paper_id = paper_id;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public boolean getIs_finished() {
        return is_finished;
    }

    public void setIs_finished(boolean is_finished) {
        this.is_finished = is_finished;
    }
}
