package edu.nju.entities;


import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.PersistenceConstructor;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.List;

@Document
public class ReviewCorrectAnswer implements java.io.Serializable{

    private static final long serialVersionUID = 7634000384125875886L;

    @Id
    private String id;

    private String item_id;

    private String report_id;

    private List<String> correct_answer;

    private String job_id;

    private String paper_id;

    private List<String> file_url;

    private String grade;

    @PersistenceConstructor
    public ReviewCorrectAnswer(String item_id, String report_id, List<String> correct_answer, String job_id, String paper_id, List<String> file_url, String grade) {
        this.item_id = item_id;
        this.report_id = report_id;
        this.correct_answer = correct_answer;
        this.job_id = job_id;
        this.paper_id = paper_id;
        this.file_url = file_url;
        this.grade = grade;
    }

    @PersistenceConstructor
    public ReviewCorrectAnswer(String item_id, String report_id, String job_id, String paper_id) {
        this.item_id = item_id;
        this.report_id = report_id;
        this.job_id = job_id;
        this.paper_id = paper_id;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getItem_id() {
        return item_id;
    }

    public void setItem_id(String item_id) {
        this.item_id = item_id;
    }

    public String getReport_id() {
        return report_id;
    }

    public void setReport_id(String report_id) {
        this.report_id = report_id;
    }

    public List<String> getCorrect_answer() {
        return correct_answer;
    }

    public void setCorrect_answer(List<String> correct_answer) {
        this.correct_answer = correct_answer;
    }

    public String getJob_id() {
        return job_id;
    }

    public void setJob_id(String job_id) {
        this.job_id = job_id;
    }

    public String getPaper_id() {
        return paper_id;
    }

    public void setPaper_id(String paper_id) {
        this.paper_id = paper_id;
    }

    public List<String> getFile_url() {
        return file_url;
    }

    public void setFile_url(List<String> file_url) {
        this.file_url = file_url;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }
}
