package edu.nju.entities;

import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.PersistenceConstructor;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.ArrayList;
import java.util.List;

@Document
public class ReviewGroup implements java.io.Serializable{

    private static final long serialVersionUID = -1113511530478451822L;

    @Id
    private String id;

    private String name;

    private String description;

    private List<String>workers_id;

    private String job_id;

    private List<String> report_id;

    //实际上是paper_id-original_id
    private List<String>paper_original_id;

    private List<String>original_id;


    @PersistenceConstructor
    public ReviewGroup(String name, String description, List<String> workers_id, String job_id, List<String> report_id,List<String>paper_original_id,List<String>original_id) {
        this.name = name;
        this.description = description;
        this.workers_id = workers_id;
        this.job_id = job_id;
        this.report_id = report_id;
        if(paper_original_id==null){
            this.paper_original_id=new ArrayList<>();
        }
        else{
            this.paper_original_id=paper_original_id;
        }
        if(original_id==null){
            this.original_id=new ArrayList<>();
        }
        else{
            this.original_id=original_id;
        }
    }

    @PersistenceConstructor
    public ReviewGroup(String id,String name, String description, List<String> workers_id, String job_id, List<String> report_id,List<String>paper_original_id,List<String>original_id) {
        this.id=id;
        this.name = name;
        this.description = description;
        this.workers_id = workers_id;
        this.job_id = job_id;
        this.report_id = report_id;
        if(paper_original_id==null){
            this.paper_original_id=new ArrayList<>();
        }
        else{
            this.paper_original_id=paper_original_id;
        }
        if(original_id==null){
            this.original_id=new ArrayList<>();
        }
        else{
            this.original_id=original_id;
        }
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public List<String> getWorkers_id() {
        return workers_id;
    }

    public void setWorkers_id(List<String> workers_id) {
        this.workers_id = workers_id;
    }

    public String getJob_id() {
        return job_id;
    }

    public void setJob_id(String job_id) {
        this.job_id = job_id;
    }

    public List<String> getReport_id() {
        return report_id;
    }

    public void setReport_id(List<String> report_id) {
        this.report_id = report_id;
    }

    public List<String> getPaper_original_id() {
        return paper_original_id;
    }

    public void setPaper_original_id(List<String> paper_original_id) {
        this.paper_original_id = paper_original_id;
    }

    public List<String> getOriginal_id() {
        return original_id;
    }

    public void setOriginal_id(List<String> original_id) {
        this.original_id = original_id;
    }
}
