package edu.nju.entities;

import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.PersistenceConstructor;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.List;

@Document
public class ReviewItem implements java.io.Serializable {

    private static final long serialVersionUID = -5938513083545319123L;

    @Id
    private String id;

    private String paper_id;

    private Boolean isRequired;

    private List<String> options;

    private String description;

    private List<String> report_id;

    private String type;


    @PersistenceConstructor
    public ReviewItem(String paper_id, Boolean isRequired, List<String> options, String description, List<String> report_id, String type) {
        this.paper_id = paper_id;
        this.isRequired = isRequired;
        this.options = options;
        this.description = description;
        this.report_id = report_id;
        this.type = type;
    }


    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getPaper_id() {
        return paper_id;
    }

    public void setPaper_id(String paper_id) {
        this.paper_id = paper_id;
    }

    public Boolean getIsRequired() {
        return isRequired;
    }

    public void setIsRequired(Boolean isRequired) {
        this.isRequired = isRequired;
    }

    public List<String> getOptions() {
        return options;
    }

    public void setOptions(List<String> options) {
        this.options = options;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public List<String> getReport_id() {
        return report_id;
    }

    public void setReport_id(List<String> report_id) {
        this.report_id = report_id;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }
}
