package edu.nju.entities;

import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.PersistenceConstructor;

public class ReviewJob implements java.io.Serializable{

    private static final long serialVersionUID = -4445308752903947027L;

    @Id
    private String id;

    private String exam_id;

    private String case_id;

    private String description;

    private String name;

    private String paper_id;

    private String create_time;

    private String start_time;

    private String end_time;

    private int single_time;

    private int total_workload;

    private String group;

    private int max_worker;

    @PersistenceConstructor
    public ReviewJob(String exam_id,String case_id, String name, String description, String create_time, String paper_id, String start_time, String end_time, Integer single_time,Integer total_workload,String group,Integer max_worker) {
        this.exam_id=exam_id;
        this.case_id=case_id;
        this.description = description;
        this.name = name;
        this.paper_id = paper_id;
        this.create_time = create_time;
        this.start_time = start_time;
        this.end_time = end_time;
        if(single_time==null){
            this.single_time=0;
        }
        else{
            this.single_time=single_time;
        }
        if(total_workload==null){
            this.total_workload=0;
        }
        else{
            this.total_workload=total_workload;
        }
        this.group = group;
        if(max_worker==null){
            this.max_worker=0;
        }
        else{
            this.max_worker=max_worker;
        }
    }
    @PersistenceConstructor
    public ReviewJob(String id,String exam_id,String case_id, String name, String description, String create_time, String paper_id, String start_time, String end_time, Integer single_time,Integer total_workload,String group,Integer max_worker) {
        this.id=id;
        this.exam_id=exam_id;
        this.case_id=case_id;
        this.description = description;
        this.name = name;
        this.paper_id = paper_id;
        this.create_time = create_time;
        this.start_time = start_time;
        this.end_time = end_time;
        if(single_time==null){
            this.single_time=0;
        }
        else{
            this.single_time=single_time;
        }
        if(total_workload==null){
            this.total_workload=0;
        }
        else{
            this.total_workload=total_workload;
        }
        this.group = group;
        if(max_worker==null){
            this.max_worker=0;
        }
        else{
            this.max_worker=max_worker;
        }

    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getExam_id() {
        return exam_id;
    }

    public void setExam_id(String exam_id) {
        this.exam_id = exam_id;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getSingle_time() {
        return single_time;
    }

    public void setSingle_time(int single_time) {
        this.single_time = single_time;
    }

    public int getTotal_workload() {
        return total_workload;
    }

    public void setTotal_workload(int total_workload) {
        this.total_workload = total_workload;
    }

    public String getPaper_id() {
        return paper_id;
    }

    public void setPaper_id(String paper_id) {
        this.paper_id = paper_id;
    }

    public String getCreate_time() {
        return create_time;
    }

    public void setCreate_time(String create_time) {
        this.create_time = create_time;
    }

    public String getStart_time() {
        return start_time;
    }

    public void setStart_time(String start_time) {
        this.start_time = start_time;
    }

    public String getEnd_time() {
        return end_time;
    }

    public void setEnd_time(String end_time) {
        this.end_time = end_time;
    }

    public String getGroup() {
        return group;
    }

    public void setGroup(String group) {
        this.group = group;
    }

    public String getCase_id() {
        return case_id;
    }

    public void setCase_id(String case_id) {
        this.case_id = case_id;
    }

    public int getMax_worker() {
        return max_worker;
    }

    public void setMax_worker(int max_worker) {
        this.max_worker = max_worker;
    }
}
