package edu.nju.entities;

import edu.nju.model.ReviewPaperVO;
import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.PersistenceConstructor;
import org.springframework.data.mongodb.core.mapping.Document;

@Document
public class ReviewPaper implements java.io.Serializable{

    private static final long serialVersionUID = 3417624501014997684L;

    @Id
    private String id;

    private String description;

    private String name;

    private String create_time;

    private String type;

    private String application_location;

    private String requirement_location;

    @PersistenceConstructor
    public ReviewPaper(String name, String create_time, String type, String description, String application_location,String requirement_location) {
        this.description = description;
        this.name = name;
        this.create_time = create_time;
        this.type = type;
        this.application_location = application_location;
        this.requirement_location = requirement_location;
    }

    @PersistenceConstructor
    public ReviewPaper(ReviewPaperVO reviewPaperVO) {
        this.description = reviewPaperVO.getDescription();
        this.name = reviewPaperVO.getName();
        this.create_time = reviewPaperVO.getCreate_time();
        this.type = reviewPaperVO.getType();
        this.application_location = reviewPaperVO.getApplication_location();
        this.requirement_location = reviewPaperVO.getRequirement_location();
    }

    @PersistenceConstructor
    public ReviewPaper(String name, String create_time, String type) {
        this.description = "";
        this.name = name;
        this.create_time =create_time;
        this.type = type;
        this.application_location = "";
        this.requirement_location = "";
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCreate_time() {
        return create_time;
    }

    public void setCreate_time(String create_time) {
        this.create_time = create_time;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getApplication_location() {
        return application_location;
    }

    public void setApplication_location(String application_location) {
        this.application_location = application_location;
    }

    public String getRequirement_location() {
        return requirement_location;
    }

    public void setRequirement_location(String requirement_location) {
        this.requirement_location = requirement_location;
    }

    //不改变id和create_time
    public void setReviewPaper(ReviewPaperVO reviewPaperVO){
        this.description = reviewPaperVO.getDescription();
        this.name = reviewPaperVO.getName();
        this.type = reviewPaperVO.getType();
        this.application_location = reviewPaperVO.getApplication_location();
        this.requirement_location = reviewPaperVO.getRequirement_location();
    }

}
