package edu.nju.entities;

import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.PersistenceConstructor;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.List;

@Document
public class ReviewReport implements java.io.Serializable {

    /**
     *
     */
    private static final long serialVersionUID = 1884350958222679356L;

    @Id
    private String id;

    //private List<String> item_id;

    private String original_id;

    private String paper_id;

    private String name;

    private String description;

    private List<String> img_url;

    private List<String> file_url;


    @PersistenceConstructor
    public ReviewReport(String original_id,String paper_id, String name, String description, List<String> img_url, List<String> file_url) {
        this.original_id=original_id;
        this.paper_id = paper_id;
        this.name = name;
        this.description = description;
        this.img_url = img_url;
        this.file_url = file_url;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

//    public List<String> getItem_id() {
//        return item_id;
//    }
//
//    public void setItem_id(List<String> item_id) {
//        this.item_id = item_id;
//    }


    public String getOriginal_id() {
        return original_id;
    }

    public void setOriginal_id(String original_id) {
        this.original_id = original_id;
    }

    public String getPaper_id() {
        return paper_id;
    }

    public void setPaper_id(String paper_id) {
        this.paper_id = paper_id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public List<String> getImg_url() {
        return img_url;
    }

    public void setImg_url(List<String> img_url) {
        this.img_url = img_url;
    }

    public List<String> getFile_url() {
        return file_url;
    }

    public void setFile_url(List<String> file_url) {
        this.file_url = file_url;
    }
}